﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinTabs;
using Infragistics.Win.UltraWinDock;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form, IUIElementCreationFilter
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraDockManager1.CreationFilter = this;
        }

        void IUIElementCreationFilter.AfterCreateChildElements(UIElement parent)
        {
            if (parent is TabRowUIElement)
            {
                var dragPane = parent.ChildElements.OfType<DragPaneElement>().FirstOrDefault();

                if (dragPane == null)
                {
                    dragPane = new DragPaneElement(parent);
                    parent.ChildElements.Insert(0, dragPane);
                }
                dragPane.Rect = parent.RectInsideBorders;
            }
        }

        bool IUIElementCreationFilter.BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
    }

    internal class DragPaneElement : PaneCaptionUIElement
    {
        public DragPaneElement(UIElement parent)
            : base(parent)
        {
        }

        protected override bool DrawTheme(ref UIElementDrawParams drawParams)
        {
            return true;
        }

        protected override void PositionChildElements()
        {
        }
    }
}
